% Main function.

clear all;
global expname

fprintf('\n\nStarting Optimization algorithm:\n\n');

[a,  b, m, h, x, y, Nt, t, dt, nu] = parameters(1);

% Total number of grid points along each direction.
Nx = m+1;

% Starting point of the trajectory.
ip1 = traj1(t(1),1);
ip2 = traj2(t(1),1); 

% Assigning initial pdf.

for i = 2:Nx-1
    for j = 2:Nx-1
        rho1(i,j) = exp((-(x(i)-ip1(1))^2-(y(j)-ip1(2))^2)/0.5);
        rho2(i,j) = exp((-(x(i)-ip2(1))^2-(y(j)-ip2(2))^2)/0.5);
    end
end
for i=1:Nx
    rho1(i,1) = 0;
    rho1(i,Nx) = 0;
    rho1(1,i) = 0;
    rho1(Nx,i) = 0;
    rho2(i,1) = 0;
    rho2(i,Nx) = 0;
    rho2(1,i) = 0;
    rho2(Nx,i) = 0;
end

% Normalizing the integral of the initial PDF to 1.
rho1 = rho1/(sum(sum(rho1))*h^2);
rho2 = rho2/(sum(sum(rho2))*h^2);

% Number of time windows.
Nw = 1;

% Final time in a time window.
T = t(Nt);

% Initial time.
T0 = t(1);
% Final time of simulation.
T1 = t(Nt)+(Nw-1)*T;

% Initializing PPDF of solutions.
sol1 = zeros(Nx,Nx,Nt); 
sol2 = zeros(Nx,Nx,Nt); 

for step = 1:Nw
    
    [u11_t,u12_t,u21_t,u22_t ] = ncg(rho1,rho2,step);
    fprintf('\n')
    fprintf('NCG ends\n');

    
       
    sol1 = fok_pl_adi(u11_t,u12_t,rho1,step);
    sol2 = fok_pl_adi_2(u21_t,u22_t,rho2,step);
    

    
    
end
fprintf('\n Saving the data in a file.\n')
% Saving data and output in a file.
expname='GaitnPosture';

fname=strcat(expname,'.mat');
save(fname,'a','b','Nx','T0','T1','Nt','u11_t','u12_t', 'u21_t', 'u22_t','ip1', 'ip2');

fprintf('\n Plotting the evolution of PDF.\n')
% Plotting the evolution of the PDF's of the 2 crowds
movie_plot;




    