function val = grad_j(u1,u2,f,p,c,kt) % Evaluating gradient of J^hat at u.

[a,b, m, h, x, y, Nt, t, dt, nu, eta] = parameters(kt);

% Evaluating the L^2 gradient using forward difference for derivative of adjoint.

val = zeros(1,Nt);
val1 = zeros(m+1,m+1,Nt);

for k = 2:Nt-1    
    for i = 2:m
        for j = 2:m
            if(c==1)
                val1(i,j,k) =  p(i,j,k)*(f(i+1,j,k)-f(i,j,k))/(h);
            else
                val1(i,j,k) =  p(i,j,k)*(f(i,j+1,k)-f(i,j,k))/(h);
            end
        end
    end
    if(c==1)
        lap = eta*(u1(k+1)-2*u1(k)+u1(k-1))/(dt^2);
        val(k) = val1(i,j,k)*h^2 + (u1(k)-lap);
    else
        lap = eta*(u2(k+1)-2*u2(k)+u2(k-1))/(dt^2);
        val(k) = val1(i,j,k)*h^2 + (nu*u2(k)-lap);
    end
    
end






